Sliding Window(滑动窗口)

Time Limit: 12000MS   Memory Limit: 65536K
Total Submissions: 58002   Accepted: 16616
Case Time Limit: 5000MS

Description

An array of size n ≤ 106 is given to you. There is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves rightwards by one position. Following is an example: 
The array is [1 3 -1 -3 5 3 6 7], and k is 3.

Window position Minimum value Maximum value
[1  3  -1] -3  5  3  6  7  -1 3
 1 [3  -1  -3] 5  3  6  7  -3 3
 1  3 [-1  -3  5] 3  6  7  -3 5
 1  3  -1 [-3  5  3] 6  7  -3 5
 1  3  -1  -3 [5  3  6] 7  3 6
 1  3  -1  -3  5 [3  6  7] 3 7

Your task is to determine the maximum and minimum values in the sliding window at each position.

Input

The input consists of two lines. The first line contains two integers n and k which are the lengths of the array and the sliding window. There are n integers in the second line.

Output

There are two lines in the output. The first line gives the minimum values in the window at each position, from left to right, respectively. The second line gives the maximum values.

Sample Input

8 3
1 3 -1 -3 5 3 6 7

Sample Output

-1 -3 -3 -3 3 3
3 3 5 5 6 7

Source

POJ Monthly--2006.04.28, Ikki

题目描述

现在有一堆数字共N个数字(N<=10^6),以及一个大小为k的窗口。现在这个从左边开始向右滑动,每次滑动一个单位,求出每次滑动后窗口中的最大值和最小值。

例如:

The array is [1 3 -1 -3 5 3 6 7], and k = 3.

输入输出格式

输入格式:

输入一共有两行,第一行为n,k。

第二行为n个数(<INT_MAX).

输出格式:

输出共两行,第一行为每次窗口滑动的最小值

第二行为每次窗口滑动的最大值

输入输出样例

输入样例#1:

8 3
1 3 -1 -3 5 3 6 7

输出样例#1:

-1 -3 -3 -3 3 3
3 3 5 5 6 7

说明

50%的数据,n<=10^5

100%的数据,n<=10^6

思路:单调队列。

分别维护一个单调上升队列和一个单调下降队列即可。

拿区间最大值来说吧,一个上升队列,它的队首值就是区间最大值。

如果窗口向后滑动,首先,在满足队列单调的前提下,把新值加入(不一定真的加入)。

如果队首值等于要去掉的值,队首后移。

代码实现:

 1 #include<cstdio>
 2 #define maxn 1000010
 3 int n,k,s[maxn];
 4 int a;
 5 int h1,t1,q1[maxn],a1[maxn],l1;
 6 int h2,t2,q2[maxn],a2[maxn],l2;
 7 int main(){
 8     scanf("%d%d",&n,&k);
 9     for(int i=1;i<=n;i++){
10         scanf("%d",&s[i]);
11         a=h1-1;h1=t1;
12         for(int j=a;j>=t1;j--) if(s[i]>=q1[j]){h1=j+1;break;}
13         q1[h1++]=s[i];
14         if(i>k&&s[i-k]==q1[t1]) t1++;//因为判断先后的问题,一直RE一个点。
15         if(i>=k) a1[l1++]=q1[t1];
16         a=h2-1;h2=t2;
17         for(int j=a;j>=t2;j--) if(s[i]<=q2[j]){h2=j+1;break;}
18         q2[h2++]=s[i];
19         if(i>k&&s[i-k]==q2[t2]) t2++;
20         if(i>=k) a2[l2++]=q2[t2];
21     }
22     for(int i=0;i<l1;i++) printf("%d ",a1[i]);putchar(‘\n‘);
23     for(int i=0;i<l2;i++) printf("%d ",a2[i]);putchar(‘\n‘);
24     return 0;
25 }

另一种写法(更工整些):

 1 #include<cstdio>
 2 #define maxn 1000010
 3 int n,k,s[maxn];
 4 int a;
 5 int h1,t1,q1[maxn],a1[maxn],l1;
 6 int h2,t2,q2[maxn],a2[maxn],l2;
 7 int main(){
 8     scanf("%d%d",&n,&k);
 9     for(int i=1;i<=n;i++){
10         scanf("%d",&s[i]);
11         q1[h1++]=1000000000;q2[h2++]=-1000000000;
12         for(int j=t1;j<h1;j++)
13         if(s[i]<q1[j]){q1[j]=s[i];h1=j+1;break;}
14         if(i>k&&s[i-k]==q1[t1]) t1++;
15         if(i>=k) a1[l1++]=q1[t1];
16         for(int j=t2;j<h2;j++)
17         if(s[i]>q2[j]){q2[j]=s[i];h2=j+1;break;}
18         if(i>k&&s[i-k]==q2[t2]) t2++;
19         if(i>=k) a2[l2++]=q2[t2];
20     }
21     for(int i=0;i<l1;i++) printf("%d ",a1[i]);putchar(‘\n‘);
22     for(int i=0;i<l2;i++) printf("%d ",a2[i]);putchar(‘\n‘);
23     return 0;
24 }

也可以分开写:

 1 #include<cstdio>
 2 #define maxn 1000010
 3 int n,k,a,h,t;
 4 int s[maxn],q[maxn];
 5 int main(){
 6     scanf("%d%d",&n,&k);
 7     for(int i=1;i<=n;i++){
 8         scanf("%d",&s[i]);
 9         q[h++]=1000000000;
10         for(int j=t;j<h;j++) if(s[i]<q[j]){q[j]=s[i];h=j+1;break;}
11         if(i>k&&s[i-k]==q[t]) t++;
12         if(i>=k) printf("%d ",q[t]);
13     }
14     putchar(‘\n‘);h=t=0;
15     for(int i=1;i<=n;i++){
16         q[h++]=-1000000000;
17         for(int j=t;j<h;j++) if(s[i]>q[j]){q[j]=s[i];h=j+1;break;}
18         if(i>k&&s[i-k]==q[t]) t++;
19         if(i>=k) printf("%d ",q[t]);
20     }
21     putchar(‘\n‘);
22     return 0;
23 }

越来越短。

最后被poj接受的代码(2266mm):

 1 #include<cstdio>
 2 #define maxn 1000010
 3 int n,k,s[maxn];
 4 int a;
 5 int h1,t1,q1[maxn],a1[maxn],l1;
 6 int h2,t2,q2[maxn],a2[maxn],l2;
 7 inline int abs(int x){return x<0?-x:x;}
 8 void write(int x){
 9     if(x) write(x/10);
10     else return;
11     putchar(x%10+‘0‘);
12 }
13 int main(){
14     scanf("%d%d",&n,&k);
15     for(int i=1;i<=n;i++){
16         scanf("%d",&s[i]);
17         a=h1-1;h1=t1;
18         for(int j=a;j>=t1;j--) if(s[i]>=q1[j]){h1=j+1;break;}
19         q1[h1++]=s[i];
20         if(i>k&&s[i-k]==q1[t1]) t1++;
21         if(i>=k) a1[l1++]=q1[t1];
22         a=h2-1;h2=t2;
23         for(int j=a;j>=t2;j--) if(s[i]<=q2[j]){h2=j+1;break;}
24         q2[h2++]=s[i];
25         if(i>k&&s[i-k]==q2[t2]) t2++;
26         if(i>=k) a2[l2++]=q2[t2];
27     }
28     for(int i=0;i<l1;i++){
29         if(a1[i]<0) putchar(‘-‘);
30         write(abs(a1[i]));
31         if(!a1[i]) putchar(‘0‘);
32         if(i<l1-1) putchar(‘ ‘);
33     }
34     putchar(‘\n‘);
35     for(int i=0;i<l2;i++){
36         if(a2[i]<0) putchar(‘-‘);
37         write(abs(a2[i]));
38         if(!a2[i]) putchar(‘0‘);
39         if(i<l2-1) putchar(‘ ‘);
40     }
41     putchar(‘\n‘);
42     return 0;
43 }

题目来源:POJ,洛谷

时间: 2024-10-17 12:04:01

Sliding Window(滑动窗口)的相关文章

洛谷P1886 滑动窗口(POJ.2823 Sliding Window)(区间最值)

To 洛谷.1886 滑动窗口 To POJ.2823 Sliding Window 题目描述 现在有一堆数字共N个数字(N<=10^6),以及一个大小为k的窗口.现在这个从左边开始向右滑动,每次滑动一个单位,求出每次滑动后窗口中的最大值和最小值. 例如: The array is [1 3 -1 -3 5 3 6 7], and k = 3. 输入输出格式 输入格式: 输入一共有两行,第一行为n,k. 第二行为n个数(<INT_MAX). 输出格式: 输出共两行,第一行为每次窗口滑动的最小值

[leetcode]239. Sliding Window Maximum滑动窗口最大值

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position. Return the max sliding

[Swift]LeetCode480. 滑动窗口中位数 | Sliding Window Median

Median is the middle value in an ordered integer list. If the size of the list is even, there is no middle value. So the median is the mean of the two middle value. Examples: [2,3,4] , the median is 3 [2,3], the median is (2 + 3) / 2 = 2.5 Given an a

TCP-IP详解:滑动窗口(Sliding Window)

参考书籍:TCP-IP Guide TCP的优势 从传输数据来讲,TCP/UDP以及其他协议都可以完成数据的传输,从一端传输到另外一端,TCP比较出众的一点就是提供一个可靠的,流控的数据传输,所以实现起来要比其他协议复杂的多,先来看下这两个修饰词的意义: 1. Reliability ,提供TCP的可靠性,TCP的传输要保证数据能够准确到达目的地,如果不能,需要能检测出来并且重新发送数据. 2. Data Flow Control,提供TCP的流控特性,管理发送数据的速率,不要超过设备的承载能力

[LeetCode] Sliding Window Maximum 滑动窗口最大值

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position. For example,Given nums

TCP滑动窗口Sliding Window

滑动窗口的发送窗口示意图如下,其中由对端通告的窗口窗口大小为6,窗口中和窗口外的数据分别表示为:1-3发送并已经被确认的数据段,4-6发送但尚未被确认的数据段,7-9能够发送尚未发送的数据段,10-…位于窗口外不能够被发送的数据: 窗口边沿的移动示意图如下,当接收方确认数据后,这个滑动窗口不时的向右移动.窗口的两个边沿的相对运动增加或者减少了窗口的大小.我们使用三个术语来描述左右边沿的运动: (1) 称窗口的左边沿向右边沿靠近称为窗口合拢.这种现象发生在数据被发送和确认时: (2) 当窗口的右边

239. Sliding Window Maximum *HARD* -- 滑动窗口的最大值

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the knumbers in the window. Each time the sliding window moves right by one position. For example,Given nums 

POJ 2823 Sliding Window (滑动窗口的最值问题 )

Sliding Window Time Limit: 12000MS   Memory Limit: 65536K Total Submissions: 41264   Accepted: 12229 Case Time Limit: 5000MS Description An array of size n ≤ 106 is given to you. There is a sliding window of size k which is moving from the very left

多尺度滑动窗口法,multiple-scale sliding window method

当前的人体检测技术,基本都会采用到多尺度滑动窗口法,该方法需要对图像做不同尺度的缩放,然后用固定大小的滑动窗口以等距步长在整幅图像上滑动,并对每一个滑动窗口做人体检测. 因此,这个方法的最大优点就是漏检率极低,因为它会对整幅图像都滑动,不会漏掉任何一个可能会出现人体的位置.但是这种优势,是用巨大的搜索空间和时间消耗换来的,检测效率自然会受到较大的影响.这个方法的大致原理,可用下面的流程图演示. 我们以大小为480*640的图像为例,缩放尺度为1.1,首先构建图片中最左侧的金字塔(构建金字塔的结束